Merge "Adds Barometer service"
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-bgpvpn-opendaylight.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-netvirt-vpp.yaml"
39       else
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
41       fi
42     else
43       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight.yaml"
44     fi
45     SDN_IMAGE=opendaylight
46   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
47     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
48     SDN_IMAGE=opendaylight
49   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
50     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
51       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-onos-sfc.yaml"
52     else
53       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-onos.yaml"
54     fi
55     SDN_IMAGE=onos
56   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
57     if [[ "$ha_enabled" == "True" ]]; then
58       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
59       echo "${red}OVN HA support is not not supported... exiting.${reset}"
60       exit 1
61     else
62       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
63     fi
64     SDN_IMAGE=opendaylight
65   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
66     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
67     exit 1
68   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
69     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
70     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
71       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
72     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
73       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
74     fi
75     SDN_IMAGE=opendaylight
76   else
77     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
78     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
79     exit 1
80   fi
81
82   # Enable Tacker
83   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
84     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
85   fi
86
87   # Enable Congress
88   if [ "${deploy_options_array['congress']}" == 'True' ]; then
89     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
90   fi
91
92   # Enable Real Time Kernel (kvm4nfv)
93   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
94     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
95   fi
96
97   # Enable Barometer service
98   if [ "${deploy_options_array['barometer']}" == 'True' ]; then
99     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_barometer.yaml"
100   fi
101
102 # Make sure the correct overcloud image is available
103   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
104       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
105       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
106       exit 1
107   fi
108
109   echo "Copying overcloud image to Undercloud"
110   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
111   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
112
113   # disable neutron openvswitch agent from starting
114   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
115       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
116       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
117       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
118                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
119                                                -a overcloud-full.qcow2
120 EOI
121   fi
122
123   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
124       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
125       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
126       LIBGUESTFS_BACKEND=direct virt-customize \
127          --run-command "systemctl enable zrpcd" \
128          -a overcloud-full.qcow2
129 EOI
130   fi
131
132   # Install ovs-dpdk inside the overcloud image if it is enabled.
133   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
134     # install dpdk packages before ovs
135     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
136
137     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
138       cat << EOF > vfio_pci.modules
139 #!/bin/bash
140 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
141 EOF
142
143       cat << EOF > uio_pci_generic.modules
144 #!/bin/bash
145 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
146 EOF
147
148       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
149                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
150                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
151                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
152                                                -a overcloud-full.qcow2
153
154       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
155         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
156       fi
157
158 EOI
159
160   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
161     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
162     exit 1
163   fi
164
165   if [ "$debug" == 'TRUE' ]; then
166     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
167   fi
168
169   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
170   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
171     echo "ONOS SFC is currently unavailable. JIRA: APEX-417"
172     exit 1
173     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
174          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
175                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
176                                                   -a overcloud-full.qcow2
177 EOI
178   fi
179
180   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
181   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
182     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
183       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
184                                                -a overcloud-full.qcow2
185 EOI
186
187     # Configure routing node and interface role mapping for odl-fdio
188     if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['odl_vpp_routing_node']}" != 'dvr' ]]; then
189       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
190         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
191         sed -i "/ControllerExtraConfig:/ c\  ControllerExtraConfig:\n    tripleo::profile::base::neutron::agents::honeycomb::interface_role_mapping:  ['${tenant_nic_mapping_controller_members}:tenant-interface']" ${ENV_FILE}
192         sed -i "/NovaComputeExtraConfig:/ c\  NovaComputeExtraConfig:\n    tripleo::profile::base::neutron::agents::honeycomb::interface_role_mapping:  ['${tenant_nic_mapping_compute_members}:tenant-interface','${external_nic_mapping_compute_members}:public-interface']" ${ENV_FILE}
193 EOI
194     fi
195   fi
196
197   if [ -n "${deploy_options_array['performance']}" ]; then
198     ovs_dpdk_perf_flag="False"
199     for option in "${performance_options[@]}" ; do
200       if [ "${arr[1]}" == "vpp" ]; then
201         if [ "${arr[0]}" == "Compute" ]; then
202           role='NovaCompute'
203         else
204           role=${arr[0]}
205         fi
206         if [ "${arr[2]}" == "main-core" ]; then
207           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
208             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_main_core: '${arr[3]}'" ${ENV_FILE}
209 EOI
210         elif [ "${arr[2]}" == "corelist-workers" ]; then
211           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
212             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_corelist_workers: '${arr[3]}'" ${ENV_FILE}
213 EOI
214         fi
215       fi
216       arr=($option)
217       # use compute's kernel settings for all nodes for now.
218       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
219         kernel_args+=" ${arr[2]}=${arr[3]}"
220       fi
221       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
222          eval "${arr[2]}=${arr[3]}"
223          ovs_dpdk_perf_flag="True"
224       fi
225     done
226
227     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
228       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
229       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
230       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
231 EOI
232
233     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
234       for ovs_option in ${!ovs_option_heat_arr[@]}; do
235         if [ -n "${!ovs_option}" ]; then
236           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
237             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
238 EOI
239         fi
240       done
241     fi
242   fi
243
244   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
245     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
246       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
247         echo -e "${blue}INFO: nosdn fdio deployment...installing correct vpp packages...${reset}"
248         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
249           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
250 EOI
251       else
252         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
253         exit 1
254       fi
255     fi
256   fi
257
258   # Set ODL version accordingly
259   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
260     case "${deploy_options_array['odl_version']}" in
261       carbon) odl_version=''
262               ;;
263       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon'.${reset}"
264          exit 1
265          ;;
266     esac
267
268     if [[  -n "$odl_version" ]]; then
269         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
270           LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
271                                                    --run-command "yum -y install /root/${odl_version}/*" \
272                                                    -a overcloud-full.qcow2
273 EOI
274     fi
275
276     # Overwrite puppet-opendaylight with carbon. By default we install boron branch.
277     if [ "${deploy_options_array['odl_version']}" == 'carbon' ]; then
278       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
279         LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /etc/puppet/modules/opendaylight" \
280                                                  --run-command "cd /etc/puppet/modules/ && tar xzf /root/puppet-opendaylight-carbon.tar.gz" \
281                                                  -a overcloud-full.qcow2
282 EOI
283     fi
284   fi
285
286   # Override ODL for fdio scenarios
287   if [[ "${deploy_options_array['odl_vpp_netvirt']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
288     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
289       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
290                                                --run-command "yum -y install /root/opendaylight-7.0.0-0.1.20170531snap665.el7.noarch.rpm" \
291                                                -a overcloud-full.qcow2
292 EOI
293 #  elif [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
294 #    if [[ "${deploy_options_array['odl_vpp_routing_node']}" != 'dvr' ]]; then
295 #      ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
296 #        LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /opt/opendaylight/*" \
297 #                                                 --run-command "tar zxvf /root/fdio_odl_carbon.tar.gz -C /opt/opendaylight/ --strip-components=1" \
298 #                                                 --run-command "chown odl:odl -R /opt/opendaylight" \
299 #                                                 -a overcloud-full.qcow2
300 #EOI
301 #    fi
302   fi
303
304   # check if ceph should be enabled
305   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
306     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
307   fi
308
309   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
310     # The epoch in deloran's ovs is 1: and in leif's is 0:
311     # so we have to execute a downgrade instead of an update
312     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
313       LIBGUESTFS_BACKEND=direct virt-customize \
314         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
315         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
316         -a overcloud-full.qcow2
317 EOI
318   fi
319
320   # get number of nodes available in inventory
321   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
322   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
323
324   # check if HA is enabled
325   if [[ "$ha_enabled" == "True" ]]; then
326     if [ "$num_control_nodes" -lt 3 ]; then
327       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
328       exit 1
329     else
330      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
331      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
332      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
333     fi
334   else
335     if [ "$num_control_nodes" -lt 1 ]; then
336       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
337       exit 1
338     fi
339   fi
340
341   if [ "$num_compute_nodes" -le 0 ]; then
342     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
343     exit 1
344   else
345     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
346     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
347   fi
348
349   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
350
351   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
352   if [[ "$virtual" == "TRUE" ]]; then
353      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
354      echo 'Ensuring Virtual BMC device status'
355      for i in $(vbmc list | grep down | awk '{ print $2}'); do
356          vbmc start $i
357          sleep 5
358      done
359      vbmc list
360   fi
361
362   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
363
364   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
365 # Create a key for use by nova for live migration
366 echo "Creating nova SSH key for nova resize support"
367 ssh-keygen -f nova_id_rsa -b 1024 -P ""
368 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
369 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
370 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
371 mv -f opnfv-environment-new.yaml ${ENV_FILE}
372
373 source stackrc
374 set -o errexit
375 # Workaround for APEX-207 where sometimes swift proxy is down
376 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
377   sudo systemctl restart openstack-swift-proxy
378 fi
379 echo "Uploading overcloud glance images"
380 openstack overcloud image upload
381
382 echo "Configuring undercloud and discovering nodes"
383
384
385 if [[ -z "$virtual" ]]; then
386   openstack overcloud node import instackenv.json
387   openstack overcloud node introspect --all-manageable --provide
388   #if [[ -n "$root_disk_list" ]]; then
389     # TODO: replace node configure boot with ironic node-update
390     # TODO: configure boot is not used in ocata here anymore
391     #openstack overcloud node configure boot --root-device=${root_disk_list}
392     #https://github.com/openstack/tripleo-quickstart-extras/blob/master/roles/overcloud-prep-images/templates/overcloud-prep-images.sh.j2#L73-L130
393     #ironic node-update $ironic_node add properties/root_device='{"{{ node['key'] }}": "{{ node['value'] }}"}'
394   #fi
395 else
396   openstack overcloud node import --provide instackenv.json
397 fi
398
399 openstack flavor set --property "cpu_arch"="x86_64" baremetal
400 openstack flavor set --property "cpu_arch"="x86_64" control
401 openstack flavor set --property "cpu_arch"="x86_64" compute
402 echo "Configuring nameserver on ctlplane network"
403 dns_server_ext=''
404 for dns_server in ${dns_servers}; do
405   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
406 done
407 openstack subnet set ctlplane-subnet \${dns_server_ext}
408 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
409 echo "Executing overcloud deployment, this could run for an extended period without output."
410 sleep 60 #wait for Hypervisor stats to check-in to nova
411 # save deploy command so it can be used for debugging
412 cat > deploy_command << EOF
413 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
414 EOF
415 EOI
416
417   if [ "$interactive" == "TRUE" ]; then
418     if ! prompt_user "Overcloud Deployment"; then
419       echo -e "${blue}INFO: User requests exit${reset}"
420       exit 0
421     fi
422   fi
423
424   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
425 source stackrc
426 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
427 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
428   $(typeset -f debug_stack)
429   debug_stack
430   exit 1
431 fi
432 EOI
433
434   # Configure DPDK and restart ovs agent after bringing up br-phy
435   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
436     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
437 source stackrc
438 set -o errexit
439 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
440 echo "Checking DPDK status and bringing up br-phy on \$node"
441 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
442 set -o errexit
443 sudo dpdk-devbind -s
444 sudo ifup br-phy
445 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
446   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
447   sudo systemctl restart neutron-openvswitch-agent
448 fi
449 EOF
450 done
451 EOI
452   fi
453
454   if [ "$debug" == 'TRUE' ]; then
455       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
456 source overcloudrc
457 echo "Keystone Endpoint List:"
458 openstack endpoint list
459 echo "Keystone Service List"
460 openstack service list
461 EOI
462   fi
463 }